<?php
/*
Plugin Name: WordPress Email Notification Plugin v2.1.1
Plugin URI: http://watershedstudio.com/portfolio/software/wp-email-notification.html
Description: Allow People To Sign Up For E-Mail Notifications
Author: Brian Groce
Version: 2.1.1
Author URI: http://briangroce.com/
*/ 

//********************************************************//
//                    CREATE VARIABLES
//********************************************************//
if(!isset($wpdb->posts)) {
   $wpdb->posts               = $table_prefix . 'posts';
   $wpdb->postmeta            = $table_prefix . 'postmeta';
   $wpdb->users               = $table_prefix . 'users';
  }

if(!isset($wpdb->email_list)) {
   $wpdb->email_list          = 'wp_email_list';
  }

//********************************************//
// email_notification_admin
//********************************************//
function email_notification_admin() {
	add_options_page(__("Email Notification"), __('Email Notification'), 8, 'wp-email-notification/index.php');
}

//********************************************//
// email_notification_form
//********************************************//
function email_notification_form($notify) {
	
	echo "
	<fieldset id=\"email_notification\">
		<legend>Notify Subscribers?</legend> 
		<div>
			<select id=\"notify\" name=\"notify\" />
				<option>Yes</option>
				<option>No</option>
			</select>
		</div>
	</fieldset>
	";
	
	return $notify;
	}

//********************************************//
// email_notification_send
//********************************************//

function email_notification_send($post_ID, $notify)  {

		//********************************************************//
		//                    GET CONFIG INFO
		//********************************************************//
			$query = "select * from wp_email_list_config where id = '1'";
			$res = mysql_query($query) or print mysql_error();
			$row = mysql_fetch_assoc($res);

			$from_email = $row['from_email'];
			$admin_email = $row['admin_email'];
			$nice_urls = $row['nice_urls'];
			$show_content = $row['show_content'];
			$html_email = $row['html_email'];

      # Site Information
      $site_name = $row['site_name'];
      $site_url = $row['site_url'];
      $blog_url = $row['blog_url'];

      # Set Global
      global $wpdb;
      
      $notify = $_POST['notify'];

    //********************************************************//
    //                   GRAB POST STATUS
    //********************************************************//
		$prev_status = $_POST['prev_status'];
		$post_status = $_POST['post_status'];

		if (isset($_POST['publish'])) $post_status = 'publish';

		//********************************************************//
		// are we going from draft/private to published?
		//********************************************************//
		if ($prev_status != 'publish' && $post_status == 'publish' && $notify == 'Yes') {

	    //********************************************************//
	    //               SELECT TITLE FROM DB
	    //********************************************************//
	    $query = "SELECT post_title, post_content FROM $wpdb->posts WHERE ID = '$post_ID'";
      $row = $wpdb->get_row($query);

	    $post_title = stripslashes($row->post_title);
      $post_title = str_replace(array("“","?","’","–","—","…"), array('"','"','','','','...'), $post_title);
      $post_title = utf8_decode($post_title);

	    $post_content = stripslashes($row->post_content);
      $post_content = str_replace(array("“","?","’","–","—","…","&nbsp;"), array('"','"','','','','...',' '), $post_content);
      $post_content = utf8_decode($post_content);

      if ($html_email != 'Yes'){
        $post_content = str_replace(array("<ul>","</ul>","<ol>","</ol>","<li>","</li>"), array('','','','','* ',''), $post_content);
        $post_content = strip_tags($post_content);
        }
      
      else {
				$post_content = $post_content . "\n"; // just to make things a little easier, pad the end
				$post_content = preg_replace('|<br />\s*<br />|', "\n\n", $post_content);
				$post_content = preg_replace('!(<(?:table|ul|ol|li|pre|form|blockquote|h[1-6])[^>]*>)!', "\n$1", $post_content); // Space things out a little
				$post_content = preg_replace('!(</(?:table|ul|ol|li|pre|form|blockquote|h[1-6])>)!', "$1\n", $post_content); // Space things out a little
				$post_content = preg_replace("/(\r\n|\r)/", "\n", $post_content); // cross-platform newlines
				$post_content = preg_replace("/\n\n+/", "\n\n", $post_content); // take care of duplicates
				$post_content = preg_replace('/\n?(.+?)(?:\n\s*\n|\z)/s', "\t<p>$1</p>\n", $post_content); // make paragraphs, including one at the end
				$post_content = preg_replace('|<p>\s*?</p>|', '', $post_content); // under certain strange conditions it could create a P of entirely whitespace
				$post_content = preg_replace("|<p>(<li.+?)</p>|", "$1", $post_content); // problem with nested lists
				$post_content = preg_replace('|<p><blockquote([^>]*)>|i', "<blockquote$1><p>", $post_content);
				$post_content = str_replace('</blockquote></p>', '</p></blockquote>', $post_content);
				$post_content = preg_replace('!<p>\s*(</?(?:table|tr|td|th|div|ul|ol|li|pre|select|form|blockquote|p|h[1-6])[^>]*>)!', "$1", $post_content);
				$post_content = preg_replace('!(</?(?:table|tr|td|th|div|ul|ol|li|pre|select|form|blockquote|p|h[1-6])[^>]*>)\s*</p>!', "$1", $post_content);
				$post_content = preg_replace('|(?<!<br />)\s*\n|', "<br />\n", $post_content); // optionally make line breaks
				$post_content = preg_replace('!(</?(?:table|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|form|blockquote|p|h[1-6])[^>]*>)\s*<br />!', "$1", $post_content);
				$post_content = preg_replace('!<br />(\s*</?(?:p|li|div|th|pre|td|ul|ol)>)!', '$1', $post_content);
				$post_content = preg_replace('/&([^#])(?![a-z]{1,8};)/', '&#038;$1', $post_content);
      	}

	    //********************************************************//
	    //                      BUILD URL
	    //********************************************************//

			if ($post_title != '' && $nice_urls == 'Yes'){
	    	// This is for the nicer URL permalink
		    $url = get_permalink($post_ID);
				}

	    else {
	      // This is for the default URL permalink
	      $url = "$blog_url/index.php?p=$post_ID";
	      }

	    //********************************************************//
	    //             SELECT USERS TO EMAIL FROM DB
	    //********************************************************//

	    $query = "SELECT email_addr FROM $wpdb->email_list WHERE gets_mail = 1";

	    $res = mysql_query($query);

	    while ($row = mysql_fetch_assoc($res)) {
	        $addr = $row['email_addr'];

        //********************************************************//
        //                 HTML VERSION OF MESSAGE
        //********************************************************//

				if ($html_email == 'Yes'){

  				if ($post_title != ''){
  					$msg =  "A new entry titled '$post_title' has been posted to $site_name.<br /><br />";
  					}

  				else {
  					$msg =  "A new entry has been posted to $site_name.<br /><hr />";
  					}

          if ($show_content == 'Yes') {
            $msg .= "$post_content<br />";
            }

    	      $msg .= "<a href=\"$url\">$url</a><br />";
    	      $msg .= "<hr />";
  					$msg .= "You have signed up to receive these notifications. <br /><br />";
  					$msg .= "If you would like to unsubscribe, visit the url below:<br />";

 	          // This is for the default URL permalink
  	        $msg .= "<a href=\"$site_url/maillist/index.php?action=unsub&addr=$addr\">$site_url/maillist/index.php?action=unsub&addr=$addr</a><br />";

            }

        //********************************************************//
        //                 TEXT VERSION OF MESSAGE
        //********************************************************//

        else {
  				if ($post_title != ''){
  					$msg =  "A new entry titled '$post_title' has been posted to $site_name.\n\n";
  					}

  				else {
  					$msg =  "A new entry has been posted to $site_name.\n\n";
  					}

          if ($show_content == 'Yes') {
            $msg .= "$post_content\n\n";
            }

    	      $msg .= "$url\n\n";
    	      $msg .= "------------------------------------------------------\n\n";
  					$msg .= "You have signed up to receive these notifications. \n\n";
  					$msg .= "If you would like to unsubscribe, visit the url below:\n";

 	          // This is for the default URL permalink
 	          $msg .= "$site_url/maillist/index.php?action=unsub&addr=$addr\n";

  	        }

        //********************************************************//
        //                     EMAIL HEADER
        //********************************************************//
            $header  = "MIME-Version: 1.0\r\n";

            if ($html_email == 'Yes'){
             $header .= "Content-Type: text/html; charset=\"" . get_settings('blog_charset') . "\"\r\n";
              }

            else {
              $header .= "Content-Type: text/plain; charset=\"" . get_settings('blog_charset') . "\"\r\n";
              }

  					$header .= "From: $site_name <$from_email>\n";
            $header .= "Reply-To: $from_email\n";
            $header .= "Return-Path: $from_email\n";

        //********************************************************//
        //                        SUBJECT
        //********************************************************//
  					if ($post_title != ''){
              $subject = "$site_name: $post_title";
              }

  					else {
  					  $subject = "$site_name: New Untitled Entry";
  						}

        //********************************************************//
        //                        MAIL IT
        //********************************************************//

						Mail($addr, $subject, $msg, $header);
	    }

		} // end if moving from draft/private to published

    return $post_ID;  // It may be buggy otherwise.

}

//********************************************//
// Actions
//********************************************//

// Notify box in advanced mode
add_action('edit_form_advanced', 'email_notification_form');

// Notify box in simple mode
add_action('simple_edit_form', 'email_notification_form');

// Notify box in page mode
add_action('edit_page_form', 'email_notification_form');

// Admin menu
add_action('admin_menu', 'email_notification_admin');

// Send the notification
add_action('publish_post', 'email_notification_send', 5);

?>